unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, ComCtrls, Grids,Shellapi;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    Button2: TButton;
    Image2: TImage;
    Button3: TButton;
    StringGrid1: TStringGrid;
    StatusBar1: TStatusBar;
    Button1: TButton;
    Button4: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    TabSheet1: TTabSheet;
    Image3: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BNew(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
 TMassivImage = record
    x,y:integer;
    w,h:Integer;
    Bit:Tbitmap;
 end;
var
  Form1: TForm1;
  ImMas:array of TMassivImage;
  ImMasCount:integer;
    rm,rx,ry:integer;
   r:Trect;
   MashtabX:integer;
   MashtabY :integer;
   cx,cy:integer;
   dvig:boolean=false;
   ci:integer;
   dx,dy:integer;
   DvigBit:Tbitmap;
   tx,ty:integer;

   CountX,CountY:integer;
implementation

{$R *.dfm}

  //   
   Function GetImageWH(thumbnail:Timage;maxWidth,maxHeight:integer):Trect;
   begin
   result.Left:=0;result.top:=0;
    if thumbnail.Width > thumbnail.Height then
    begin
      result.Right := maxWidth-2;
      result.Bottom := (maxWidth * thumbnail.Height) div thumbnail.Width;
    end
    else
    begin
      result.Bottom := maxHeight-2;
      result.Right := (maxHeight * thumbnail.Width) div thumbnail.Height;
    end;
    end;

procedure TForm1.Button1Click(Sender: TObject);
var x,y:integer;
begin
  form1.Image2.Canvas.Pen.Color:=clred;
  form1.Image2.Canvas.Rectangle(form1.Image2.Canvas.ClipRect);
  rx:=GetImageWH(form1.Image1,form1.Image1.Width,form1.Image1.Height).Right div (CountX+1);
  ry:=GetImageWH(form1.Image1,form1.Image1.Width,form1.Image1.Height).Bottom div (CountY+1);
  DvigBit:=Tbitmap.Create;
  DvigBit.Width:=rx+1;
  DvigBit.Height:=ry+1;
  r:=GetImageWH(form1.Image1,form1.Image1.Width,form1.Image1.Height);

  MashtabX:=1;
  MashtabY:=1;

  ImMasCount:=0;
  Setlength(ImMas,ImMasCount);
  form1.Image2.Canvas.pen.Color:=clred;
  form1.Image2.Canvas.pen.Width:=1;
  for X:=0 to CountX do
  for y:=0 to CountY do begin
      ImMasCount:=ImMasCount+1;
      Setlength(ImMas,ImMasCount);
      ImMas[ImMasCount-1].x:=x;
      ImMas[ImMasCount-1].y:=y;
      ImMas[ImMasCount-1].Bit:=Tbitmap.Create;
      ImMas[ImMasCount-1].Bit.Width:=rx*MashtabX;
      ImMas[ImMasCount-1].Bit.height:=ry*MashtabY;
      ImMas[ImMasCount-1].Bit.canvas.CopyRect(rect(0,0,rx,ry),
      image1.Canvas,
      rect(rx*x*MashtabX,ry*y*MashtabY,(rx*x+rx)*MashtabX,(ry*y+ry)*MashtabY));
      form1.Image2.Canvas.Rectangle(rect(rx*x*MashtabX,ry*y*MashtabY,(rx*x+rx)*MashtabX,(ry*y+ry)*MashtabY));
      form1.Image2.Canvas.CopyRect(rect(rx*x*MashtabX+1,ry*y*MashtabY+1,(rx*x+rx)*MashtabX-1,(ry*y+ry)*MashtabY-1),ImMas[ImMasCount-1].Bit.canvas,rect(0,0,rx*MashtabX-1,ry*MashtabY-1));
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
CountX:=3;
CountY:=3;
   form1.Image1.Picture.LoadFromFile('din2.bmp');
   Button1Click(nil);
   Button3Click(nil);
end;

procedure TForm1.Button3Click(Sender: TObject);
label loop;
var i,x,y:integer;

begin

  for X:=0 to CountX do
  for y:=0 to CountY do begin
     form1.StringGrid1.Cells[x,y]:='-1';
  end;

  for I:=0 to ImMasCount-1 do begin
  loop:
    x:=random(CountX+1);
    y:=random(CountY+1);
    if form1.StringGrid1.Cells[x,y]='-1' then begin
    form1.StringGrid1.Cells[x,y]:=inttostr(i);
       ImMas[i].x:=x;
       ImMas[i].y:=y;
    end
    else goto loop;
    application.ProcessMessages;
  end;


for X:=0 to CountX do
  for y:=0 to CountY do begin
  for I:=0 to ImMasCount-1 do begin
      if ImMas[i].x=x then
      if ImMas[i].y=y then begin
      form1.Image2.Canvas.Rectangle(rect(rx*x*MashtabX,ry*y*MashtabY,(rx*x+rx)*MashtabX,(ry*y+ry)*MashtabY));
      form1.Image2.Canvas.CopyRect(rect(rx*x*MashtabX+1,ry*y*MashtabY+1,(rx*x+rx)*MashtabX-1,(ry*y+ry)*MashtabY-1),ImMas[i].Bit.canvas,rect(0,0,rx*MashtabX-1,ry*MashtabY-1));
      end;end;
  end;
  end;
procedure TForm1.Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
  t2,t:Trect;
begin
  if dvig then begin

    t:=rect(0,0,rx,ry);
    t2:=rect(cx,cy,cx+rx,cy+ry);
    form1.Image2.Canvas.CopyRect(t2,dvigbit.Canvas,t);
    cY:=y-ty;
    cx:=x-ty;
    t2:=rect(cx,cy,cx+rx,cy+ry);
    dvigBit.Canvas.CopyRect(t,form1.Image2.Canvas,t2);
    form1.Image2.Canvas.CopyRect(t2,ImMas[cI].Bit.Canvas,t);
  end;


   form1.StatusBar1.Panels[0].Text:='X = '+Inttostr(x)+' : '+'Y = '+Inttostr(y)+'  '+inttostr(x div rx)+':'+inttostr(y div ry);

end;
Function GetCI(cx,cy:integer):integer;
var i:integer;
begin
result:=-1;
  for i:=0 to ImMasCount-1 do
  if (ImMas[i].x=cx) and (ImMas[i].y=cy) then begin
    result:=i;
    exit;
  end;
end;
//Procedure Copy

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var t,t2:Trect;
   i,Ym,Xm:integer;
begin
dvig:=false;
  i:=GetCI(x div rx,y div ry);
  if i>-1 then begin
  xm:=ImMas[i].x;
  ym:=ImMas[i].y;
  cx:=x;
  cY:=y;
  tx:=cx-xm*rx;
  ty:=cy-ym*ry;
  cY:=y-ty;
  cx:=x-ty;
    t:=rect(0,0,rx,ry);
    t2:=rect(cx,cy,cx+rx,cy+ry);
    dvigBit.Canvas.CopyRect(t,form1.Image2.Canvas,t2);
 //form1.Image3.Canvas.Draw(0,0,dvigBit);
    dvig:=true;
    cI:=i;
    end;


end;

procedure TForm1.Image2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var t2,t:Trect;
  ci2:integer;
  TempX,TempY:integer;
begin
if dvig then begin
dvig:=false;

    t:=rect(0,0,rx,ry);
    t2:=rect(cx,cy,cx+rx,cy+ry);
    form1.Image2.Canvas.CopyRect(t2,dvigbit.Canvas,t);


    ci2:=GetCI(x div rx ,y div ry);
    if (ci2>-1) and (ci>-1) then begin

      TempX:=ImMas[ci].x;
      TempY:=ImMas[ci].y;
      ImMas[ci].x:=ImMas[ci2].x;
      ImMas[ci].y:=ImMas[ci2].y;
      ImMas[ci2].x:=TempX;
      ImMas[ci2].y:=TempY;

      cx:=ImMas[ci].x*rx;
      cy:=ImMas[ci].y*ry;
      t:=rect(0,0,rx,ry);
      t2:=rect(cx,cy,cx+rx,cy+ry);
      form1.Image2.Canvas.Rectangle(t2.Left-1,t2.top-1,t2.Right+1,t2.Bottom+1);
      form1.Image2.Canvas.CopyRect(t2,ImMas[cI].Bit.Canvas,t);

      cx:=ImMas[ci2].x*rx;
      cy:=ImMas[ci2].y*ry;
      t:=rect(0,0,rx,ry);
      t2:=rect(cx,cy,cx+rx,cy+ry);
      form1.Image2.Canvas.Rectangle(t2.Left-1,t2.top-1,t2.Right+1,t2.Bottom+1);
      form1.Image2.Canvas.CopyRect(t2,ImMas[cI2].Bit.Canvas,t);
    end;
      for X:=0 to CountX do
       for y:=0 to CountY do begin
         form1.StringGrid1.Cells[x,y]:=inttostr(GetCI(x,y));
      end;
 end;


end;

procedure TForm1.BNew(Sender: TObject);
begin
CountX:=3;
CountY:=3;
   form1.Image1.Picture.LoadFromFile('din1.bmp');
   Button1Click(nil);
   Showmessage('1');
   Button3Click(nil);

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   form1.Image1.Picture.LoadFromFile('din2.bmp');
   Button1Click(nil);
   Showmessage(' 2 ');
   Button3Click(nil);

end;

procedure TForm1.Label2Click(Sender: TObject);
begin
   Shellapi.ShellExecute(application.Handle,'open','http://netsoftware.ucoz.ru/','','',5);
end;

end.
